/*
 *  TOPPERS/DeviceManager
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      DeviceManager
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *            Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

#include "mutex.h"
#include "stdafx.h"
#include <windows.h>

/*
 * \brief Xg}bvɍvfscopeɑ
 * \param[out] scope Xg}bṽCe[^
 * \param[in]  first T͈͂̏l
 * \param[in]  end   T͈͂̏Il
 * \param[in]  exp   T
 * ̃}N֐ĂяoƁAɍvfscopeɑD
 * ɍvfȂꍇendD
 */
#define FindIterator(scope, first, end, exp) \
	scope = first;\
	while(scope != end){\
		if(exp) break;\
		scope++;\
	}

/*
 * \brief Mutex̃RXgN^i\tgEFAV~[^̗vj
 * \param[in] id  ~[ebNXID
 * \param[in] ker voCKernelIuWFNg
 */
Mutex::Mutex(unsigned long id, class CKernel * ker)
	: id(id), count(1)
{
	KerList.push_back(ker);
}

/*
 * \brief Mutex̃RXgN^in[hEFAV~[^̗vj
 * \param[in] num ~[ebNXID
 * \param[in] dev voCDeviceIuWFNg
 */
Mutex::Mutex(unsigned long num, class CDevice * dev)
	: id(num), count(1)
{
	DevList.push_back(dev);
}

/*
 * \brief ~[ebNXIuWFNg쐬
 * \retval true  
 * \retval false s
 */
bool Mutex::Create(void)
{
	wchar_t tmp_mutex[256];
	LPCTSTR name;

	::wsprintf(tmp_mutex, L"TOPPERS/DeviceManager : Mutex(0x%08x)", id);
	bstr = static_cast<LPCOLESTR>(tmp_mutex);
	name = static_cast<LPCTSTR>(OLE2T(bstr));
	hMutex = ::CreateMutex(NULL, false, name);
	/* mۂɎsꍇ */
	if(hMutex == 0){
		return false;
	}
	/* łɓ̃~[ebNXIuWFNgꍇ */
	if(::GetLastError()){ }
	return true;
}

/*
 * \brief ~[ebNXIuWFNg폜
 * \retval true  
 * \retval false siV~[^QƂĂꍇj
 */
bool Mutex::Close(void)
{
	/* ǂ̃V~[^QƂĂȂꍇ */
	if(KerList.empty() && DevList.empty())
	{
		CloseHandle(hMutex);
		return true;
	}
	/* V~[^QƂĂꍇ */
	else
	{
		return false;
	}
}

/*
 * \brief \tgEFAV~[^QƃXgɒǉ
 * \param[in] ker   voCKernelIuWFNg
 * \retval    true  
 * \retval    false siłɃXgɂꍇj
 */
bool Mutex::AddKernel(class CKernel * ker)
{
	std::list<class CKernel *>::iterator scope;
	FindIterator( scope, KerList.begin(), KerList.end(),
		((*scope) == ker) );
	/* łɃXgɓo^Ăꍇ */
	if(scope != KerList.end())
	{
		return false;
	}
	/* Xgɓo^ĂȂꍇ */
	else
	{
		KerList.push_back(ker);
		count++;
		return true;
	}
}

/*
 * \brief n[hEFAV~[^QƃXgɒǉ
 * \param[in] dev   voCDeviceIuWFNg
 * \retval    true  
 * \retval    false siłɃXgɂꍇj
 */
bool Mutex::AddDevice(class CDevice * dev)
{
	std::list<class CDevice *>::iterator scope;
	FindIterator( scope, DevList.begin(), DevList.end(),
		((*scope) == dev) );
	/* łɃXgɓo^Ăꍇ */
	if(scope != DevList.end())
	{
		return false;
	}
	/* Xgɓo^ĂȂꍇ */
	else
	{
		DevList.push_back(dev);
		count++;
		return true;
	}
}

/*
 * \brief \tgEFAV~[^QƃXg珜
 * \param[in] ker voCKernelIuWFNg
 */
void Mutex::DeleteKernel(class CKernel * ker)
{
	std::list<class CKernel *>::iterator scope;
	FindIterator( scope, KerList.begin(), KerList.end(),
		((*scope) == ker) );
	/* Xgɓo^Ăꍇ */
	if(scope != KerList.end())
	{
		KerList.erase(scope);
		count--;
	}
}

/*
 * \brief \tgEFAV~[^QƃXg珜
 * \param[in] dev voCDeviceIuWFNg
 */
void Mutex::DeleteDevice(class CDevice * dev)
{
	std::list<class CDevice *>::iterator scope;
	FindIterator( scope, DevList.begin(), DevList.end(),
		((*scope) == dev) );
	/* Xgɓo^Ăꍇ */
	if(scope != DevList.end())
	{
		DevList.erase(scope);
		count--;
	}
}

/*
 * \brief ~[ebNXQƂĂV~[^Ԃ
 * \retval ~[ebNXQƂĂV~[^
 */
long Mutex::GetCount(void)
{
	return count;
}